
/*
 * $Id: CltXact.h,v 1.1.1.4 1999/02/20 02:39:33 rousskov Exp $
 *
 *
 * Web Polygraph  http://www.ircache.net/Polygraph/
 * ----------------------------------------------------------
 *
 *  Web Polygraph is copyrighted(C) 1998 by Alex Rousskov and
 *  the University of California, San Diego (UCSD), with all 
 *  rights reserved. Development is funded by the National Science
 *  Foundation (NLANR Cache grants NCR 9616602 and NCR 9521745).
 *  Please see the COPYRIGHT file for full details.
 *
 *  Web Polygraph is free software. You may copy and distribute 
 *  VERBATIM copies of this product. You may modify your copy 
 *  for your own use. You must NOT distribute modified copies.
 *
 *  If you publish any materials derived from or related to  
 *  Web Polygraph, you must give a credit reference to the
 *  National Science Foundation and the National Laboratory 
 *  for Applied Network Research.
 *
 *  This program is distributed WITHOUT ANY WARRANTY;
 *  without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.
 *
 */

#ifndef CLT_XACTION_H
#define CLT_XACTION_H

#include "Http.h"
#include "Oid.h"
#include "Xaction.h"

class Client;
class WrBuf;

class CltXact: public Xaction {
	public:
		CltXact() { reset(); }
		~CltXact() {}

		void reset();

		void exec(Client *anOwner, Connection *aConn);

		virtual void noteReadReady(int fd);
		virtual void noteWriteReady(int fd);

	protected:
		void makeReq(WrBuf &buf);
		void consume(Size sz);
		void finish(int errNo);
		virtual void stopStats();

	protected:
		Client *theOwner;
		RepHdr theRepHdr;
		Size theRepSize;
		Size theConsumedSize;

		OidRec theOidRec; // used to keep oid state
};

#endif
